local SKIN = "nilly"

addHook("PlayerThink", function(player)
 if player.mo and player.mo.valid and player.mo.skin == SKIN
  
  local function IsRunningOnWater(player)
        local waterBlock = player.mo.floorrover

        if (player.mo.eflags & MFE_VERTICALFLIP) then
            waterBlock = player.mo.ceilingrover
        end

        if (waterBlock) then
            return P_CanRunOnWater(player, waterBlock)
        end
    end

    local function GetFoFloorZ(player)
        local waterBlock = player.mo.floorrover

        if (player.mo.eflags & MFE_VERTICALFLIP) then
            waterBlock = player.mo.ceilingrover
        end

        if (waterBlock and waterBlock.valid) then
            local returnval = (player.mo.eflags & MFE_VERTICALFLIP) and waterBlock.bottomheight or waterBlock.topheight
            return returnval
        end
    end

    if player.wasrunningonwater == nil
     player.wasrunningonwater = 0
    end

    if IsRunningOnWater(player) or ((player.mo.eflags&MFE_TOUCHWATER) and not (player.mo.eflags&MFE_UNDERWATER)) and player.speed >= player.runspeed
     player.wasrunningonwater = 5
    end

    if (player.pflags&PF_SPINNING) and (player.mo.eflags&MFE_TOUCHWATER) and not (player.pflags&PF_JUMPED)
     if player.wasrunningonwater and player.speed >= player.runspeed and player.mo.momz/4 <= FRACUNIT*3 and player.mo.momz/4 >= -FRACUNIT*3
      player.mo.momz = -P_GetMobjGravity(player.mo)*P_MobjFlip(player.mo)
      /*if GetFoFloorZ(player) ~= nil
      player.mo.z = GetFoFloorZ(player) - P_MobjFlip(player.mo)*FRACUNIT
      end*/

      player.wasrunningonwater = 5

     local oldflags = player.pflags
     
     player.mo.eflags = $|MFE_ONGROUND
     player.pflags = oldflags
     
     if (player.cmd.buttons&BT_JUMP)
      P_DoJump(player, true)
      P_SetObjectMomZ(player.mo, FRACUNIT*102/10)
     end
     end
    end

    player.wasrunningonwater = max($ - 1, 0)
 else
  return
 end
end)